# PA165 - Airport - project

## Name
PA165 - Airport Manager

## Description
Airport Manager
Create an information system managing flight records at an airport. The system should allow the users to enter records about stewards, airplanes and destinations. It should also be possible to update and delete these records. A destination should contain at least the information about the location of an airport (country, city). Airplane details should contain the capacity of the plane and its name (and possibly its type as well). A steward is described by his first and last name. The system should also allow us to record a flight. When recording a flight, it is necessary to set the departure and arrival times, the origin, the destination and the plane. The system should also check that the plane does not have another flight scheduled during the time of the this flight. It should also be possible to assign (remove) stewards to (from) a flight while checking for the steward's availability. The ultimate goal is to have a system capable of listing flights ordered by date and displaying the flight details (origin, destination, departure time, arrival time, plane, list of stewards)

## Visuals
![Alt text](/diagrams/DTO-Diagram.jpg "DTO class diagram")
![Alt text](/diagrams/UseCase-Diagram.jpg "use case diagram")

## Installation/Running with maven
### To build with Maven
    `$mvn clean install`
### To run app on localhost
    `$mvn spring-boot:run - in each microservice separatly`

## To run using Docker/Podman compose
### To build with Maven
    $ mvn clean install
### If you want to force the images to be rebuild you can use
    $ podman image list | grep "^localhost/pa165-airport-project_" | awk '{print $3}' | xargs podman image rm
This will delete existing images.

### To run the application (all microservices)
    $ podman-compose up

### To stop the application (all microservices)
    $ podman-compose down

## Observations

### Prometheus

The prometheus collects the metrics from all 4 microservices. The UI runs at the http://localhost:9090.

### Grafana

Grafana runs at http://localhost:3000. To Log in, use the username `admin` and the password `admin`.
There is already one minimalistic dashboard imported. However, feel free to experiment and visualize another attributes.

## Scenarios

### Run scenarios
Firstly run the app
    $ cd locust-scenarios
    $ locust Admin BasicUser
Open internet browser
Type http://localhost:8089
Set: 
    - Number of users 2
    - Spawn rate 1
    - Host http://localhost


## Usage
### Used ports
+ Authorization - port 8083
+ Core - port 8080
+ Weather - port 8088
+ Report - port 8085

## Authors
+ Martin Slovík
+ Adam Krídl
+ Matej Hrica
+ Ján Macháček
